/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 * ATtinyX61ϲ ۰׌n10y16ޯ pϸ
 *
 * \par Application note:
 * AVR073: ATtiny261/461/861ł10y16ޯ ڼ޽̓o
 *
 * \par Documentation
 * IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 * B
 *
 * \author
 * Atmel Corporation: http://www.atmel.com \n
 * xҰ: avr@atmel.com
 *
 * $Name$
 * $Revision: 2571 $
 * $RCSfile$
 * $Date: 2007-10-08 15:53:50 +0200 (ma, 08 okt 2007) $  \n
 ******************************************************************************/

#ifndef __TINYX61_MACROS_H__
#define __TINYX61_MACROS_H__

#define GLOBAL_INTERRUPT_BIT_MASK	0x80	//! SREG̑S̊荞݋ޯėpޯĎՕl

#if defined(__ICCAVR__)
#include <ioavr.h>
#include "stdint.h"
#elif defined(__GNUC__)
#include <avr/io.h>
#include <stdint.h>
#include <avr/interrupt.h>
#else
// IARGCCȊO̺߲חp̲ݸٰ ̧ق͂ɑ}ł܂B
#endif

#if defined(__ICCAVR__)
#define SAVE_INTERRUPT()			__save_interrupt();						//! ݂̊荞ݏԕۑ
#define RESTORE_INTERRUPT(state)	__restore_interrupt(state);				//! 荞ݏԉ
#define DISABLE_INTERRUPT()			__disable_interrupt();					//! S̊荞݋֎~

#elif defined(__GNUC__)
#define SAVE_INTERRUPT()			SREG									//! ݂̊荞ݏԕۑ
#define RESTORE_INTERRUPT(state)	(SREG = (state))						//! 荞ݏԉ
#define DISABLE_INTERRUPT()			cli()									//! S̊荞݋֎~

#else
#define SAVE_INTERRUPT()			SREG									//! ݂̊荞ݏԕۑ
#define RESTORE_INTERRUPT(state)	(SREG = (state))						//! 荞ݏԉ
#define DISABLE_INTERRUPT()			(SREG &= (~GLOBAL_INTERRUPT_BIT_MASK))	//! S̊荞݋֎~
#endif

/*! \brief TCNT0ւ16ޯď
 *
 * TCNT0(TCNT0H/L)16ޯĒl܂B
 *
 *  \param value V16ޯĂTCNT0l
 */
#define TC0_WRITE_TCNT0(value) \
  { \
	TCNT0H = (uint8_t)((value) >> 8); \								// ޲Đݒ
	TCNT0L = (uint8_t)(value); \									// ޲Đݒ
  }

/*! \brief TCNT016ޯĒlǂݍ
 *
 * TCNT0(TCNT0H/L)16ޯĒlǂ݂܂B
 *
 *  \param destinationVariable 擾ϐ
 */
#define TC0_READ_TCNT0(destinationVariable) \
  { \
	uint8_t tempL; \												// ǂݍݒlꎞϐ
	tempL = TCNT0L; \												// ޲Ēl擾
	(destinationVariable) = ((TCNT0H << 8) | tempL); \				// ޲Ēl擾,ϐɐݒ
  }

/*! \brief TCNT0ւ̔񕪒f16ޯď
 *
 * 1̔񕪒fTCNT0(TCNT0H/L)16ޯĒl܂B
 *
 *  \param value V16ޯĂTCNT0l
 */
#define TC0_WRITE_TCNT0_INT_SAFE(value) \
  { \
	uint8_t iFlagTemp; \											// S̊荞݋ޯėpꎞϐ
	iFlagTemp = SAVE_INTERRUPT(); \									// ݂̑S̊荞݋ޯĒlۑ
	DISABLE_INTERRUPT(); \											// S̊荞݈ꎞ֎~
	TCNT0H = (uint8_t)((value) >> 8); \								// ޲Đݒ
	TCNT0L = (uint8_t)(value); \									// ޲Đݒ
	RESTORE_INTERRUPT(iFlagTemp); \									// S̊荞݋ޯĒl
  }

/*! \brief TCNT0̔񕪒f16ޯēǂݍ
 *
 * 1̔񕪒fTCNT0(TCNT0H/L)16ޯĒlǂ݂܂B
 *
 *  \param destinationVariable 擾ϐ
 */
#define TC0_READ_TCNT0_INT_SAFE(destinationVariable) \
  { \
	uint8_t iFlagTemp; \											// S̊荞݋ޯėpꎞϐ
	uint8_t tempL; \												// ǂݍݒlꎞϐ
	iFlagTemp = SAVE_INTERRUPT(); \									// ݂̊荞݋ޯĒlۑ
	DISABLE_INTERRUPT(); \											// S̊荞݈ꎞ֎~
	tempL = TCNT0L; \												// ޲Ēl擾
	(destinationVariable) = ((TCNT0H << 8) | tempL); \				// ޲Ēl擾,ϐɐݒ
	RESTORE_INTERRUPT(iFlagTemp); \									// S̊荞݋ޯĒl
  }

/*! \brief OCR0B/Aւ16ޯď
 *
 * OCR0B/A16ޯĒl܂B
 *
 *  \param value V16ޯĂOCR0B/Al
 */
#define TC0_WRITE_16_BIT_OCR0AB(value) \
  { \
	OCR0B = (uint8_t)((value) >> 8); \								// ޲Đݒ
	OCR0A = (uint8_t)(value);\										// ޲Đݒ
  }

/*! \brief OCR0B/A16ޯĒlǂݍ
 *
 * OCR0B/A16ޯĒlǂ݂܂B
 *
 *  \param destinationVariable 擾ϐ
 */
#define TC0_READ_16_BIT_OCR0AB(destinationVariable) \
  { \
	uint8_t tempL = OCR0A; \										// ޲Ēl擾
	(destinationVariable) = ((uint16_t)OCR0B << 8) | tempL; \		// ޲Ēl擾,ϐɐݒ
  }

/*! \brief OCR0B/Aւ̔񕪒f16ޯď
 *
 * 1̔񕪒fOCR0B/A16ޯĒl܂B
 *
 *  \param value V16ޯĂOCR0B/Al
 */
#define TC0_WRITE_16_BIT_OCR0AB_INT_SAFE(value) \
  { \
	uint8_t iFlagTemp; \											// S̊荞݋ޯėpꎞϐ
	iFlagTemp = SAVE_INTERRUPT(); \									// ݂̊荞݋ޯĒlۑ
	DISABLE_INTERRUPT(); \											// S̊荞݈ꎞ֎~
	OCR0B = (uint8_t)((value) >> 8); \								// ޲Đݒ
	OCR0A = (uint8_t)(value);\										// ޲Đݒ
	RESTORE_INTERRUPT(iFlagTemp); \									// S̊荞݋ޯĒl
  }

/*! \brief OCR0B/A̔񕪒f16ޯēǂݍ
 *
 * 1̔񕪒fOCR0B/A16ޯĒlǂ݂܂B
 *
 *  \param destinationVariable 擾ϐ
 */
#define TC0_READ_16_BIT_OCR0AB_INT_SAFE(destinationVariable) \
  { \
	uint8_t iFlagTemp; \											// S̊荞݋ޯėpꎞϐ
	iFlagTemp = SAVE_INTERRUPT(); \									// ݂̊荞݋ޯĒlۑ
	DISABLE_INTERRUPT(); \											// S̊荞݈ꎞ֎~
	uint8_t tempL = OCR0A; \										// ޲Ēl擾
	(destinationVariable) = ((uint16_t)OCR0B << 8) | tempL; \		// ޲Ēl擾,ϐɐݒ
	RESTORE_INTERRUPT(iFlagTemp); \									// S̊荞݋ޯĒl
  }

/*! \brief /1ڼ޽ւ10ޯĒl
 *
 * /1̂ǂꂩ10ޯ ڼ޽10ޯĒl܂B
 *
 *  \param destinationRegister	ݐڼ޽
 *  \param value				ݒl
 */
#define TC1_WRITE_10_BIT_REGISTER(destinationRegister, value) \
  { \
	TC1H = ((value) >> 8); \										// 2ޯĐݒ
	(destinationRegister) = (uint8_t)(value); \						// ޲Đݒ
  }

/*! \brief /1ڼ޽10ޯĒlǂݍ
 *
 * /1̂ǂꂩ10ޯ ڼ޽10ޯĒlǂ݂܂B
 *
 *  \param sourceRegister		ǂݍ݌ڼ޽
 *  \param destinationVariable	ǂݍݐϐ
 */
#define TC1_READ_10_BIT_REGISTER(sourceRegister, destinationVariable) \
  { \
	uint8_t tempL; \												// ǂݍݒlꎞϐ
	tempL = (sourceRegister); \										// ޲Ēl擾
	(destinationVariable) = ( ((uint16_t)TC1H << 8) | tempL); \		// 2ޯĒl擾,ϐɐݒ
  }

/*! \brief /1ڼ޽ւ̔񕪒f10ޯĒl
 *
 * 1̔񕪒f/1̂ǂꂩ10ޯ ڼ޽10ޯĒl܂B
 *
 *  \param destinationRegister	ݐڼ޽
 *  \param value				ݒl
 */
#define TC1_WRITE_10_BIT_REGISTER_INT_SAFE(destinationRegister, value) \
  { \
	uint8_t iFlagTemp; \											// S̊荞݋ޯėpꎞϐ
	iFlagTemp = SAVE_INTERRUPT(); \									// ݂̊荞݋ޯĒlۑ
	DISABLE_INTERRUPT(); \											// S̊荞݈ꎞ֎~
	TC1H = ((value) >> 8); \										// 2ޯĐݒ
	(destinationRegister) = (uint8_t)(value); \						// ޲Đݒ
	RESTORE_INTERRUPT(iFlagTemp); \									// S̊荞݋ޯĒl
  }

/*! \brief /1ڼ޽̔񕪒f10ޯĒlǂݍ
 *
 * 1̔񕪒f/1̂ǂꂩ10ޯ ڼ޽10ޯĒlǂ݂܂B
 *
 *  \param sourceRegister		ǂݍ݌ڼ޽
 *  \param destinationVariable	ǂݍݐϐ
 */
#define TC1_READ_10_BIT_REGISTER_INT_SAFE(sourceRegister, destinationVariable) \
  { \
	uint8_t iFlagTemp; \											// S̊荞݋ޯėpꎞϐ
	uint8_t tempL; \												// ǂݍݒlꎞϐ
	iFlagTemp = SAVE_INTERRUPT(); \									// ݂̊荞݋ޯĒlۑ
	tempL = (sourceRegister); \										// ޲Ēl擾
	(destinationVariable) = ( ((uint16_t)TC1H << 8) | tempL); \		// 2ޯĒl擾,ϐɐݒ
	RESTORE_INTERRUPT(iFlagTemp); \									// S̊荞݋ޯĒl
  }

/*! \brief /1̑Soقɑ΂铯rlݒ
 *
 * ϸۂ/13SĂ̔rقɓrlݒ肵܂B͒P
 * rڼ޽ɂđSĂق䂳PWM6ɑΉ܂B
 *
 *  \param compareValue Vrl
 */
#define TC1_SET_ALL_COMPARE_VALUES(compareValue) \
  { \
	uint16_t tempValue = compareValue; \							// wrl
	TC1H = ((uint8_t)((tempValue) >> 8)); \							// 2ޯĐݒ(ȉSĂɓKp)
	OCR1A = ((uint8_t)tempValue); \									// 2ޯĂ𔺂OCR1A޲Đݒ
	OCR1B = ((uint8_t)tempValue); \									// 2ޯĂ𔺂OCR1B޲Đݒ
	OCR1D = ((uint8_t)tempValue); \									// 2ޯĂ𔺂OCR1C޲Đݒ
  }

#endif
