/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief pid.cpͯ ̧
 *
 * - ̧		: pid.h
 * - ߲		: IAR EWAAVR 4.11A
 * - x޲	: SĂAVR޲gp\łB
 * - pLq	: AVR449 - ATtiny261/461/861gp3ivӰ̐쓮
 *
 * \author		Atmel Corporation: http://www.atmel.com \n
 *				xEҰ: avr@atmel.com
 *
 * $Name$
 * $Revision: 2571 $
 * $RCSfile$
 * $Date: 2007-10-08 15:53:50 +0200 (ma, 08 okt 2007) $
 *****************************************************************************/

#ifndef PID_H
#define PID_H

#include "stdint.h"

#define SCALING_FACTOR  256			// PIDpkڌW

/*! \brief PID
 *
 * PIDZ@ɂĎgpݒ_ް
 */
typedef struct PID_DATA{
  int16_t lastProcessValue;			//! l̔T̂ɗpAŌ̏l
  int32_t sumError;					//! ϕvZɎgpA덷̑a
  int16_t P_Factor;					//! gWŏZ(~100)ꂽAᒲ萔
  int16_t I_Factor;					//! gWŏZ(~100)ꂽAϕ萔
  int16_t D_Factor;					//! gWŏZ(~100)ꂽA萔
  int16_t maxError;					//! 邽߂́Aő勖e덷
  int32_t maxSumError;				//! 邽߂́Aő勖ea덷
} pidData_t;

/*! \brief ől
 *
 * ƈ̖邽߂ɕKvƂ܂B
 */
#define MAX_INT		INT16_MAX		//! Px^ől
#define MAX_LONG	INT32_MAX		//! {x^ől
#define MAX_I_TERM	(MAX_LONG / 2)	//! ϕ̔{x^ől

// _l
#define FALSE		0				//! FALSE萔
#define TRUE		(!FALSE)		//! TRUE萔

// ֐^錾
void pid_Init(int16_t p_factor, int16_t i_factor, int16_t d_factor, struct PID_DATA *pid);
int16_t pid_Controller(int16_t setPoint, int16_t processValue, struct PID_DATA *pid_st);
void pid_Reset_Integrator(pidData_t *pid_st);

#endif
